// meta data operations are non-void functions

#include "headers.hh"
#include "array.hh"

#define max_array_size  15


// container functions

#define Firstfld head->Container << ".first"
#define Arrfld   head->Container << ".arr["

void array_container::elemxform(void)
{ // add nothing
}

void array_container::cursxform(void)
{ // add nothing
}

void array_container::contxform(void)
{ { cout << " " << head->Obj_type << "  arr[" << max_array_size << "];\n";
   cout << "   " << head->Obj_type << " *first;\n";
   cout << "  "; }
}

void array_container::contdecl(void)
{ { cout << "CONT_TYPE " << head->Container << ""; } }

void array_container::open_cont(void)
{  { cout << "" << Firstfld << " = &" << Arrfld << "0]"; } }

void array_container::close_cont(void)
{ { cout << "/* close(" << head->Container << ") */"; } }


// cursor functions

#define firstfld cont->head->Container << ".first"
#define arrfld   cont->head->Container << ".arr["
#define obj      head->Cursor << ".obj"
  
void array_cursor::cursdecl(void)
{  { cout << "CURS_TYPE " << head->Cursor << ""; } }

void array_cursor::init_curs (void)
{ { cout << "/* init_curs( " << head->Cursor << " ) */"; };
}

void array_cursor::insert ( char* record )
{  { cout << "if (" << firstfld << " >= & " << arrfld << "" << max_array_size << "]) \n";
   cout << "        { printf(\"overflow\\n\"); exit(1); };\n";
   cout << "         " << obj << " = " << firstfld << "++;\n";
   cout << "         *(" << obj << ") = *(" << cont->head->Obj_type << " *) & " << record << ";\n";
   cout << "   "; }
}

void array_cursor::foreach(void)
{  { cout << "for ( " << obj << " = &" << arrfld << " 0]; \n";
   cout << "           " << obj << " < " << firstfld << ";\n";
   cout << "           " << obj << "++ ) "; }
   if (!scan) {
      { cout << "if (" << obj << "->age >40 )"; }
   }
}

void array_cursor::remove (void)
{  { cout << " /* delete */\n";
   cout << "      {   " << cont->head->Obj_type << " *x;\n";
   cout << "          x = " << obj << ";\n";
   cout << "          while (++" << obj << " < " << firstfld << " )\n";
   cout << "             *(" << obj << "-1) = *" << obj << ";\n";
   cout << "          " << obj << " = --x;\n";
   cout << "          " << firstfld << "--;\n";
   cout << "      }\n";
   cout << "   "; }
}


void array_cursor::ref( char* field )
{ cout << "" << head->Cursor << ".obj->" << field << ""; }

void array_cursor::getrec( char* buffer )
{ cout << " " << buffer << " = * ( " << cont->head->Orig_type << " *) " << obj << "; "; }


// component functions

array::array(DS* layer)
{
   if (layer != 0) {
      cout << "Error: array has no parameters\n";
      exit(1);
   }
}

int array::drc(int post)
{  // no preconditions or postconditions
   // no prerestrictions (since array is terminal)
   // retrieval postrestrict
   return retrieval;
}

DS_container* array::make_container(CONTAINER *hd)
{  array_container* k = new array_container;
   k->head      = hd;
   return k;
}

DS_cursor* array::make_cursor( DS_container *Cont, Bool Scan, CURSOR* Head )
{  array_cursor* c = new array_cursor;
   c->head        = Head;
   c->cont        = (array_container*) Cont;
   c->scan        = Scan;
   return c;
}

