#include "headers.hh" 

// TEQN functions

TEQN::TEQN(void)
{  lower = 0; 
}

void TEQN::drc(void) 
{  
   if (failure(retrieval, lower->drc(0))) {
      cout << "type equation error  - missing retrieval layer\n";
      exit(1);
   }
}

CONTAINER* TEQN::make_container(char* name)
{
   CONTAINER *c      = new CONTAINER;
   c->Container      = name;
   c->Container_type = "CONT_TYPE";
   c->Obj_type       = "ELE_TYPE";
   c->Orig_type      = "EMP_TYPE";
   c->lower          = lower->make_container(c);
   return c;
}

CURSOR* TEQN::make_cursor(CONTAINER* cont, Bool scan, char *name)
{
   CURSOR *c      = new CURSOR;
   c->Cursor      = name;
   c->Cursor_type = "CURS_TYPE";
   c->lower       = lower->make_cursor(cont->lower, scan, c);
   return c;
}


// CONTAINER functions

void  CONTAINER::elemxform (void)
{  lower->elemxform(); }

void  CONTAINER::cursxform (void)
{  lower->cursxform(); }

void  CONTAINER::contxform (void)
{  lower->contxform(); }
 
void  CONTAINER::contdecl (void)
{  lower->contdecl(); }
 
void  CONTAINER::open_cont (void)
{  lower->open_cont(); }
 
void  CONTAINER::close_cont (void)
{  lower->close_cont(); }
 

// CURSOR functions

void CURSOR::cursdecl (void)
{  lower->cursdecl(); }

void CURSOR::init_curs (void)
{  lower->init_curs(); }

void CURSOR::insert (char* r)
{  lower->insert(r); }

void CURSOR::foreach (void)
{  lower->foreach(); }

void CURSOR::remove (void)
{  lower->remove(); }

void CURSOR::ref (char* fld)
{  lower->ref(fld); }

void CURSOR::getrec (char* buffer)
{  lower->getrec(buffer); }
