// meta data operations are non-void functions

#include "headers.hh"
#include "delflag.hh"

#define   CR cout << ";\n"

// container functions


void delflag_container::elemxform(void)
{  cout << "int   df;\n   ";
   lower->elemxform();
}

void delflag_container::cursxform(void)
{ lower->cursxform(); }

void delflag_container::contxform(void)
{ lower->contxform(); }

void delflag_container::contdecl(void)
{  lower->contdecl(); }

void delflag_container::open_cont(void)
{  lower->open_cont(); }

void delflag_container::close_cont(void)
{  lower->close_cont(); }


// cursor functions

#define dffld    head->Cursor << ".obj->df"
#define obj      head->Cursor << ".obj"
  
void delflag_cursor::cursdecl(void)
{  lower->cursdecl(); }

void delflag_cursor::init_curs (void)
{  lower->init_curs(); }

void delflag_cursor::insert ( char* record )
{  lower->insert(record); CR;
   cout << "      " << dffld << " = 0";
}

void delflag_cursor::foreach(void)
{  
   lower->foreach();
   cout << "     if (!" << dffld << ")";
}

void delflag_cursor::remove (void)
{  cout << dffld << " = 1;"; }


void delflag_cursor::ref( char* field )
{  lower->ref(field); }

void delflag_cursor::getrec( char* buffer )
{  lower->getrec(buffer);  }


// component functions

delflag::delflag(DS* layer)
{
   lower = layer;
}

int delflag::drc(int post)
{  int postres;

   // preconditions are that there is a lower component and delflag
   // hasn't been used before, postconditions df_seen

   if (!failure(df_seen,post)) {
      cout << "too many delflag layers in type equation\n";
      exit(1);
   }
   if (!lower) {
      cout << "delflag precondition error - lower level component missing\n";
      exit(1);
   }
   postres = lower->drc(post | df_seen );
   // no prerestrictions, postrestriction is stability
   return postres | stability;
}

DS_container* delflag::make_container(CONTAINER *hd)
{  delflag_container* k = new delflag_container;
   k->head              = hd;
   k->teqn              = this;
   k->lower             = lower->make_container(hd);
   return k;
}

DS_cursor* delflag::make_cursor( DS_container *Cont, Bool Scan, CURSOR* Head )
{  delflag_container* k = (delflag_container*) Cont;
   delflag_cursor* c = new delflag_cursor;
   c->head        = Head;
   c->cont        = k;
   c->scan        = Scan;
   c->teqn        = this;
   c->lower       = lower->make_cursor( k->lower, Scan, Head );
   return c;
}
