// meta data operations are non-void functions

#include "headers.hh"
#include "dlist.hh"

#define   CR cout << ";\n   "

// container functions

#define Frstfld  head->Container << ".frst"
#define Lastfld   head->Container << ".last"

void dlist_container::elemxform(void)
{  cout << "struct ele   *next;\n";
   cout << "   struct ele   *prev;\n   ";
   lower->elemxform();
}

void dlist_container::cursxform(void)
{  lower->cursxform(); }

void dlist_container::contxform(void)
{  cout << head->Obj_type << "   *frst;\n";
   cout << "   " << head->Obj_type << "   *last;\n   ";
   lower->contxform();
}

void dlist_container::contdecl(void)
{  lower->contdecl(); }

void dlist_container::open_cont(void)
{
   lower->open_cont(); CR;
   cout << Frstfld << " = 0;\n";
   cout << "  " << Lastfld  << " = 0";
}

void dlist_container::close_cont(void)
{  lower->close_cont(); }


// cursor functions

#define frstfld  cont->head->Container << ".frst"
#define lastfld   cont->head->Container << ".last"
#define nextfld   head->Cursor << ".obj->next"
#define prevfld   head->Cursor << ".obj->prev"
#define obj       head->Cursor << ".obj"
  
void dlist_cursor::cursdecl(void)
{  lower->cursdecl(); }

void dlist_cursor::init_curs (void)
{  lower->init_curs(); }

void dlist_cursor::insert ( char* record )
{  lower->insert(record); CR;
   cout << "   " << prevfld << " = " << lastfld << ";\n   ";
   cout << "   " << lastfld << " = " << obj     << ";\n   ";
   cout << "   " << nextfld <<  " = 0;\n   ";
   cout << "   if ( " << prevfld << " ) " << prevfld;
   cout << "->next = " << obj <<";\n   ";
   cout << "   if ( !" << frstfld << " ) " << frstfld << " = " << obj ;
}

void dlist_cursor::foreach(void)
{
   cout << "for( " << obj << " = " << frstfld << "; ";
   cout << obj << "; ";
   cout << obj << " = " << nextfld << " )";
   if (!scan)
      cout << "\n    if (" << obj << "->age >40 )";
}

void dlist_cursor::remove (void)
{  cout << "if ( " << nextfld << " ) ";
   cout << nextfld << "->prev = " << prevfld << ";\n";
   cout << "    if ( " << prevfld << " ) ";
   cout << prevfld << "->next = " << nextfld << ";\n";
   cout << "    if ( " << frstfld << " == " << obj  << " ) ";
   cout << frstfld << " = " << nextfld ";\n   ";
   cout << "    if ( " << lastfld << " == " << obj  << " ) ";
   cout << lastfld << " = " << prevfld ";\n   ";
   lower->remove();
}

void dlist_cursor::ref( char* field )
{  lower->ref(field); }

void dlist_cursor::getrec( char* buffer )
{  lower->getrec(buffer);  }


// component functions

dlist::dlist(DS* layer)
{
   lower = layer;
}

int dlist::drc(int post)
{  int postres;

   // preconditions are that there be a lower component
   // and dlist hasn't been used before
   // postconditions are retrieval and dlist_seen

   if (!lower) {
      cout << "dlist precondition error - lower level component missing\n";
      exit(1);
   }
   if (!failure(dlist_seen,post)) {
      cout << "too many dlist layers in type equation\n";
      exit(1);
   }

   postres = lower->drc(post | retrieval | dlist_seen);
   // prerestrictions - need stability
   // postrestrictions - provide retrieval
   if (failure(stability, postres)) {
      cout << "dlist prerestriction error - needs stable layer underneath\n";
      exit(1);
   }
   return postres | retrieval;
}


DS_container* dlist::make_container(CONTAINER *hd)
{  dlist_container* k = new dlist_container;
   k->head              = hd;
   k->teqn              = this;
   k->lower             = lower->make_container(hd);
   return k;
}

DS_cursor* dlist::make_cursor( DS_container *Cont, Bool Scan, CURSOR* Head )
{  dlist_container* k = (dlist_container*) Cont;
   dlist_cursor* c = new dlist_cursor;
   c->head        = Head;
   c->cont        = k;
   c->scan        = Scan;
   c->teqn        = this;
   c->lower       = lower->make_cursor( k->lower, Scan, Head );
   return c;
}
