// meta data operations are non-void functions

#include "headers.hh"
#include "text.hh"


// container functions

void text_container::elemxform(void)
{ cout << "elemxform()"; }

void text_container::cursxform(void)
{ cout << "cursxform()"; }

void text_container::contxform(void)
{ cout << "contxform()"; }

void text_container::contdecl(void)
{ cout << "CONT_TYPE " << head->Container; }

void text_container::open_cont(void)
{ cout << "open( " << head->Container << " )";}

void text_container::close_cont(void)
{ cout << "close( " << head->Container << " )";}


// cursor functions

void text_cursor::cursdecl(void)
{  cout << "CURS_TYPE ";
   if (scan) 
      cout << "SCAN ";
   else
      cout << "NOSCAN ";
   cout << head->Cursor << "(" << cont->head->Container << ")";
}

void text_cursor::init_curs (void)
{ cout << "init_curs( " << head->Cursor << " )"; };

void text_cursor::insert ( char* record )
{ cout << "insert( " << head->Cursor << ", " << record << " )"; };

void text_cursor::foreach(void)
{ cout << "foreach( " << head->Cursor << " )"; };

void text_cursor::remove (void)
{ cout << "delete( " << head->Cursor << " )"; };

void text_cursor::ref( char* field )
{ cout << head->Cursor << "." << field ; };

void text_cursor::getrec( char* buffer )
{ cout << "getrec( " << head->Cursor << ", " << buffer << " )"; };


// component functions

text::text(DS* layer)
{
   if (layer != 0) {
      cout << "Error: text has no parameters\n";
      exit(1);
   }
}

int text::drc(int post)
{  // no preconditions, postconditions
   // no prerestrictions, but stable and retrieval postrestrictions
   // so that text can be used anywhere
   return stability | retrieval;
}

DS_container* text::make_container(CONTAINER *hd)
{  text_container* k = new text_container;
   k->head      = hd;
   return k;
}

DS_cursor* text::make_cursor( DS_container *Cont, Bool Scan, CURSOR* Head )
{  text_cursor* c = new text_cursor;
   c->head        = Head;
   c->cont        = (text_container*) Cont;
   c->scan        = Scan;
   return c;
}

