// meta data operations are non-void functions

#include "headers.hh"
#include "umalloc.hh"


// container functions

void umalloc_container::elemxform(void)
{ // add nothing
}

void umalloc_container::cursxform(void)
{ // add nothing
}

void umalloc_container::contxform(void)
{ // add nothing 
}

void umalloc_container::contdecl(void)
{ cout << "CONT_TYPE " << head->Container; }

void umalloc_container::open_cont(void)
{  cout << "/* open_cont( " << head->Container << " ) */\n";  }

void umalloc_container::close_cont(void)
{ cout << "/* close(" << head->Container << ") */";
}


// cursor functions

#define obj  head->Cursor << ".obj"

void umalloc_cursor::cursdecl(void)
{  cout << "CURS_TYPE " << head->Cursor; }

void umalloc_cursor::init_curs (void)
{ cout << "/* init_curs( " << head->Cursor << " ) */";
}

void umalloc_cursor::insert ( char* record )
{  cout << obj << " = (" << cont->head->Obj_type << "*) malloc(sizeof( ";
   cout << cont->head->Obj_type << " ));\n";
   cout << "      *( " << cont->head->Orig_type << "* ) ";
   cout << obj << " = " << record;
}

void umalloc_cursor::foreach(void)
{  cout << "ERROR - cannot expand foreach\n";
}

void umalloc_cursor::remove (void)
{  cout << "free( (char*) " << obj << " )";
}


void umalloc_cursor::ref( char* field )
{  cout << head->Cursor << ".obj->" << field ; };

void umalloc_cursor::getrec( char* buffer )
{ cout << buffer << " = * (" << cont->head->Orig_type << "*) "<< obj; }


// component functions

umalloc::umalloc(DS* layer)
{
   if (layer != 0) {
      cout << "Error: malloc has no parameters\n";
      exit(1);
   }
}

int umalloc::drc(int post)
{  // preconditions - needs retrieval, no postconditions
   if (failure(retrieval,post)) {
      cout << "malloc precondition error - needs retrieval layer above\n";
      exit(1);
   }
   // no prerestrictions, stable postrestriction
   return stability;
}

DS_container* umalloc::make_container(CONTAINER *hd)
{  umalloc_container* k = new umalloc_container;
   k->head      = hd;
   return k;
}

DS_cursor* umalloc::make_cursor( DS_container *Cont, Bool Scan, CURSOR* Head )
{  umalloc_cursor* c = new umalloc_cursor;
   c->head        = Head;
   c->cont        = (umalloc_container*) Cont;
   c->scan        = Scan;
   return c;
}
